#################################################################################
#    Class::DBI file Kaizen/RPMDE/Installations.pm
#
#    Copyright (C) 2005  Lenny Leblanc <lleblanc@macroelite.ca>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#################################################################################
package Kaizen::RPMDE::Installations;
use base 'Kaizen::RPMDE::DBI';

#for some custom methods
use Math::Round;
use File::Find;

#setup the table
__PACKAGE__->set_up_table("installations");

#setup relationships
__PACKAGE__->has_a(dateadded => "Time::Piece",
                   inflate => sub { Time::Piece->strptime(shift, "%Y-%m-%d %H:%M:%S") },
                   deflate => sub { shift->strftime("%Y-%m-%d %H:%M:%S") } );

__PACKAGE__->has_a(dateupdated => "Time::Piece",
                   inflate => sub { Time::Piece->strptime(shift, "%Y-%m-%d %H:%M:%S") },
                   deflate => sub { shift->strftime("%Y-%m-%d %H:%M:%S") } );

				   
__PACKAGE__->has_many(metagroups => "Kaizen::RPMDE::InstallationsMetaGroups","installation_id",{order_by => 'name'});

#custom methods


1;