###########################################################
#
# RPMDE Database Setup
#
# Created by: Lenny Leblanc <lleblanc@macroelite.ca>
#
###########################################################

CREATE TABLE `installations` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `dateadded` varchar(30) NOT NULL default '',
  `dateupdated` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ; 


CREATE TABLE `installations_meta_groups` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `installation_id` int(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `uservisible` varchar(10) NOT NULL default 'false',
  PRIMARY KEY  (`id`)
); 


CREATE TABLE `installations_meta_groups_link` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `sys_group_id` int(10) unsigned NOT NULL default '0',
  `installations_meta_groups_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ; 


CREATE TABLE `pending_changes` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `USER_ID` int(10) unsigned NOT NULL default '0',
  `PRIMARY_ID` int(10) unsigned NOT NULL default '0',
  `TABLE_NAME` varchar(255) NOT NULL default '',
  `FIELD_NAME` varchar(255) NOT NULL default '',
  `PROPOSED_VALUE` longblob,
  PRIMARY KEY  (`ID`)
) ; 


CREATE TABLE `rpm` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `NEXT_REVISION_ID` int(10) unsigned NOT NULL default '0',
  `NAME` varchar(100) NOT NULL default '',
  `VERSION` varchar(100) NOT NULL default '',
  `RELEASE` varchar(100) NOT NULL default '',
  `DESCRIPTION` longtext NOT NULL,
  `SUMMARY` longtext NOT NULL,
  `SYS_COPYRIGHT_ID` int(10) unsigned NOT NULL default '0',
  `SYS_DISTRIBUTION_ID` int(10) unsigned NOT NULL default '0',
  `ICON` varchar(100) NOT NULL default '',
  `VENDOR` varchar(100) NOT NULL default '',
  `URL` varchar(100) NOT NULL default '',
  `SYS_GROUP_ID` int(10) unsigned NOT NULL default '0',
  `PACKAGER_ID` int(10) unsigned NOT NULL default '0',
  `SERIAL` int(5) unsigned NOT NULL default '0',
  `AUTOREQPROV` varchar(100) NOT NULL default '',
  `PROVIDES` longtext NOT NULL,
  `EXCLUDEARCH` varchar(100) NOT NULL default '',
  `EXCLUSIVEARCH` varchar(100) NOT NULL default '',
  `EXCLUDEOS` varchar(100) NOT NULL default '',
  `EXCLUSIVEOS` varchar(100) NOT NULL default '',
  `PREFIX` varchar(100) NOT NULL default '',
  `BUILDROOT` varchar(100) NOT NULL default '',
  `DEFINES` longtext NOT NULL,
  `PREP` longtext NOT NULL,
  `BUILD` longtext NOT NULL,
  `INSTALL` longtext NOT NULL,
  `CLEAN` longtext NOT NULL,
  `PRE` longtext NOT NULL,
  `POST` longtext NOT NULL,
  `PREUN` longtext NOT NULL,
  `POSTUN` longtext NOT NULL,
  `VERIFYSCRIPT` longtext NOT NULL,
  `FILES` longtext NOT NULL,
  `DATEADDED` varchar(100) NOT NULL default '',
  `DATEUPDATED` varchar(100) NOT NULL default '',
  `RPMSIZE` varchar(100) NOT NULL default '0',
  `SRPMSIZE` varchar(100) NOT NULL default '0',
  `TYPE` enum('mandatory','default','optional') default 'optional',
  `RPM_MD5SUM` varchar(100) NOT NULL default '',
  `SRPM_MD5SUM` varchar(100) default NULL,
  PRIMARY KEY  (`ID`)
) ; 


CREATE TABLE `rpm_buildqueue` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `RPM_ID` int(10) unsigned NOT NULL default '0',
  `BUILD_TYPE` int(10) unsigned NOT NULL default '0',
  `USER_ID` int(10) unsigned NOT NULL default '0',
  `STATUS` enum('building','waiting','done') NOT NULL default 'waiting',
  `LOG_FILE` varchar(255) NOT NULL default '',
  `START_TIME` varchar(100) NOT NULL default '2005-01-01 01:00:00',
  `END_TIME` varchar(100) NOT NULL default '2005-01-01 01:00:00',
  PRIMARY KEY  (`ID`)
) ; 


CREATE TABLE `rpm_changelog` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `RPM_ID` int(10) unsigned NOT NULL default '0',
  `USER_ID` int(10) unsigned NOT NULL default '0',
  `DATE` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `DESCRIPTION` longtext NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `Secondary` (`RPM_ID`,`USER_ID`)
) ; 


CREATE TABLE `rpm_conflicts` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `RPM_ID` int(10) unsigned NOT NULL default '0',
  `CONFLICT_RPM_ID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `Secondary` (`RPM_ID`,`CONFLICT_RPM_ID`)
) ; 


CREATE TABLE `rpm_patch` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `RPM_ID` int(10) unsigned NOT NULL default '0',
  `PATCH` varchar(255) NOT NULL default '',
  `INCLUDE` int(1) unsigned NOT NULL default '0',
  `size` varchar(100) NOT NULL default '',
  `md5sum` varchar(100) default NULL,
  PRIMARY KEY  (`ID`),
  KEY `Secondary` (`RPM_ID`)
) ; 


CREATE TABLE `rpm_requires` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `RPM_ID` int(10) unsigned NOT NULL default '0',
  `NAME` varchar(100) NOT NULL default '',
  `VERSION` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `Secondary` (`RPM_ID`)
) ; 


CREATE TABLE `rpm_source` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `RPM_ID` int(10) unsigned NOT NULL default '0',
  `SOURCE` varchar(255) NOT NULL default '',
  `ORIGINAL` varchar(255) NOT NULL default '',
  `INCLUDE` int(1) unsigned NOT NULL default '0',
  `size` varchar(100) NOT NULL default '',
  `md5sum` varchar(100) default NULL,
  PRIMARY KEY  (`ID`),
  KEY `Secondary` (`RPM_ID`)
) ; 


CREATE TABLE `rpm_status` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `RPM_ID` int(10) unsigned NOT NULL default '0',
  `SPEC` int(1) unsigned NOT NULL default '0',
  `BUILD` int(1) unsigned NOT NULL default '0',
  `IN_PROGRESS` int(1) unsigned NOT NULL default '0',
  `SUCCESS` int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) ; 


CREATE TABLE `rpm_subpackages` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `RPM_ID` int(10) unsigned NOT NULL default '0',
  `NAME` varchar(255) NOT NULL default '',
  `DESCRIPTION` longtext NOT NULL,
  `SUMMARY` longtext NOT NULL,
  `SYS_GROUP_ID` int(10) unsigned NOT NULL default '0',
  `FILES` longtext NOT NULL,
  `PRE` longtext NOT NULL,
  `POST` longtext NOT NULL,
  `PREUN` longtext NOT NULL,
  `POSTUN` longtext NOT NULL,
  `VERIFYSCRIPT` longtext NOT NULL,
  `RPMSIZE` varchar(100) NOT NULL default '',
  `MD5SUM` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`ID`),
  KEY `Secondary` (`RPM_ID`,`NAME`(20),`DESCRIPTION`(20),`SUMMARY`(20))
) ; 


CREATE TABLE `sys_builds` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `DESCRIPTION` varchar(255) NOT NULL default '',
  `PARAMETERS` varchar(255) NOT NULL default '',
  `BUILD_ORDER` int(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) ; 

LOCK TABLES `sys_builds` WRITE;
INSERT INTO `sys_builds` VALUES (1,'Execute %prep','-bp',25),(2,'Execute %prep, %build','-bc',20),(3,'Execute %prep, %build, %install','-bi',15),(4,'Execute %prep, %build, %install (package bin)','-bb',10),(5,'Execute %prep, %build, %install (package bin, src)','-ba',5),(6,'Check %files list','-bl --timecheck 3600',30),(7,'Short Circuit to %install','-bi --short-circuit',27);
UNLOCK TABLES;


CREATE TABLE `sys_copyright` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `NAME` varchar(255) NOT NULL default '',
  `DESCRIPTION` longtext NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `Secondary` (`NAME`(20),`DESCRIPTION`(20))
) ; 

LOCK TABLES `sys_copyright` WRITE;
INSERT INTO `sys_copyright` VALUES (12,'AAL','Attribution Assurance Licenses'),(7,'AFL','Academic Free License'),(9,'AL2','Apache License 2.0'),(10,'APSL','Apple Public Source License'),(11,'ART','Artistic License'),(8,'ASL','Apache Software License'),(5,'BSD','BSD License'),(13,'CPL','Common Public License'),(1,'GPL','GNU General Public License'),(2,'LGPL','GNU Library or \"Lesser\" General Public License'),(4,'MPL','Mozilla Public License'),(14,'PHP','PHP License'),(15,'PSFL','Python Software Foundation License'),(16,'QPL','Qt Public License'),(17,'SCL','Sleepycat License'),(18,'SISSL','Sun Industry Standards Source License'),(6,'W3C','W3C License'),(19,'ZPL','Zope Public License'),(20,'TCL/TK','TCL/TK License'),(21,'MIT','MIT License'),(22,'OSI','OSI Approved'),(23,'SENDMAIL','Sendmail License'),(24,'PUBLICDOMAIN','Public domain (uncopyrighted)'),(25,'OPENLDAP','OpenLDAP Public License'),(26,'WUFTPD','WU-FTPD Software License');
UNLOCK TABLES;


CREATE TABLE `sys_distribution` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `NAME` varchar(255) NOT NULL default '',
  `dirname` varchar(100) default NULL,
  PRIMARY KEY  (`ID`)
) ; 

LOCK TABLES `sys_distribution` WRITE;
INSERT INTO `sys_distribution` VALUES (1,'Distro Name Here','distrodir/');
UNLOCK TABLES;


CREATE TABLE `sys_ftpservers` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `host` varchar(255) NOT NULL default '',
  `port` int(5) unsigned NOT NULL default '0',
  `username` varchar(100) NOT NULL default '',
  `password` varchar(100) NOT NULL default '',
  `basedir` longtext NOT NULL,
  `dateupdated` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ; 

LOCK TABLES `sys_ftpservers` WRITE;
INSERT INTO `sys_ftpservers` VALUES (1,'FTP Server','0.0.0.0',22,'username','password','/base/path/to/yum/repository/','0000-00-00 00:00:00');
UNLOCK TABLES;


CREATE TABLE `sys_group` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `NAME` varchar(255) NOT NULL default '',
  `textid` varchar(255) default NULL,
  `description` longtext,
  `def_value` varchar(10) default 'true',
  `uservisible` varchar(10) default 'true',
  PRIMARY KEY  (`ID`)
) ; 

LOCK TABLES `sys_group` WRITE;
INSERT INTO `sys_group` VALUES (1,'Amusements/Games','amusements-games','Games','true','true'),(2,'Amusements/Graphics','amusements-graphics','Graphics','true','true'),(3,'Applications/Archiving','applications-archiving','Archiving Tools','true','true'),(4,'Applications/Communications','applications-communications','Communications','true','true'),(5,'Applications/Databases','applications-database','Databases','true','true'),(6,'Applications/Editors','applications-editors','Editors','true','true'),(7,'Applications/Emulators','applications-emulators','Emulators','true','true'),(8,'Applications/Engineering','applications-engineering','Engineering','true','true'),(9,'Applications/File','applications-file','File','true','true'),(10,'Applications/Internet','applications-internet','Internet','true','true'),(11,'Applications/Multimedia','applications-multimedia','Multimedia','true','true'),(12,'Applications/Productivity','applications-productivity','Productivity','true','true'),(13,'Applications/Publishing','applications-publishing','Publishing','true','true'),(14,'Applications/System','applications-system','System','true','true'),(15,'Applications/Text','applications-text','Text','true','true'),(16,'Development/Debuggers','development-debuggers','Debuggers','true','true'),(17,'Development/Languages','development-languages','Languages','true','true'),(18,'Development/Libraries','development-libraries','Libraries','true','true'),(19,'Development/System','development-system','System','true','true'),(20,'Development/Tools','development-tools','Development Tools','true','true'),(21,'Documentation/Documentation','documentation-documentation','Documentation','true','true'),(22,'System Environment/Base','system-base','Base','true','true'),(23,'System Environment/Daemons','system-daemons','Daemons','true','true'),(24,'System Environment/Kernel','system-kernel','Kernel','true','true'),(25,'System Environment/Libraries','system-libraries','Libraries','true','true'),(26,'System Environment/Shells','system-shells','Shells','true','true'),(27,'User Interface/Desktops','x-desktops','Desktops','true','true'),(28,'User Interface/X','x-base','Base','true','true'),(29,'User Interface/X Hardware Support','x-hardware-support','Hardware Support','true','true');
UNLOCK TABLES;


CREATE TABLE `sys_menu` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `NAME` varchar(100) NOT NULL default '',
  `HREF` varchar(255) NOT NULL default '',
  `MENU_ORDER` int(2) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) ; 

LOCK TABLES `sys_menu` WRITE;
INSERT INTO `sys_menu` VALUES (1,'Home','/home',2),(2,'RPMs','/rpms',4),(8,'Admin','/admin',13),(7,'Logout','/logout',15),(5,'Update YUM','/updateyum',10),(6,'Installations','/installation',12);
UNLOCK TABLES;


CREATE TABLE `sys_security` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `PATH` varchar(255) NOT NULL default '',
  `MIN_USER_LEVEL` int(4) unsigned NOT NULL default '10',
  PRIMARY KEY  (`ID`)
) ; 

LOCK TABLES `sys_security` WRITE;
INSERT INTO `sys_security` VALUES (1,'/login',40),(2,'/search',40),(3,'/',40),(4,'',40),(5,'/home',40),(6,'/rpms',40),(7,'/newrpm',10),(8,'/managerpm',40),(9,'/viewrpm',40),(10,'/editrpm',30),(11,'/generatespec',40),(12,'/buildrpm',20),(13,'/buildrpm/viewlog',20),(14,'/buildrpm/delete',10),(15,'/executerpm',20),(16,'/updateyum',20),(17,'/updateyum/doit',20),(18,'/installation',10),(19,'/installation/buildiso',10),(20,'/installation/new',10),(21,'/installation/metagroups',10),(22,'/admin',10),(23,'/admin/users',10),(24,'/admin/users/add',10),(25,'/admin/users/delete',10),(26,'/admin/users/edit',10),(27,'/admin/users/save',10),(28,'/deleterpm',10),(29,'/deletesubpackage',20),(30,'/editrpm/editpatch',30),(31,'/editrpm/deletepatch',30),(32,'/editrpm/updatepatch',30),(33,'/editrpm/editsource',30),(34,'/editrpm/updatesource',30),(35,'/error',40),(36,'/installation/edit',10),(37,'/installation/delete',10),(38,'/installation/store',10),(39,'/installation/update',10),(40,'/installation/buildiso/doit',10),(41,'/installation/grouphierarchy',10),(42,'/installation/metagroups/edit',10),(43,'/installation/metagroups/delete',10),(44,'/installation/metagroups/new',10),(45,'/installation/metagroups/store',10),(46,'/installation/metagroups/update',10),(47,'/logout',40),(48,'/newchangelog',30),(49,'/newpatch',30),(50,'/newrequire',30),(51,'/newsource',30),(52,'/newsubpackage',30),(53,'/savechangelog',30),(54,'/savepatch',30),(55,'/saverequire',30),(56,'/saverpm',10),(57,'/savesource',30),(58,'/savesubpackage',30),(59,'/updaterpm',30),(60,'/editrpm/deletesource',30);
UNLOCK TABLES;

CREATE TABLE `users` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `NAME` varchar(255) NOT NULL default '',
  `EMAIL` varchar(255) NOT NULL default '',
  `USERLEVEL_ID` int(10) unsigned NOT NULL default '0',
  `CHROOT_DIR` varchar(255) default '',
  `USERNAME` varchar(100) NOT NULL default '',
  `PASSWORD` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`ID`)
)  COMMENT='user information'; 

LOCK TABLES `users` WRITE;
INSERT INTO `users` VALUES (1,'Admin User','admin@',10,'chrootdir','username','6d98684b668859ca'),(12,'Demo Account','questions@macroelite.ca',40,'demo','demo','6d98684b668859ca');
UNLOCK TABLES;


CREATE TABLE `users_level` (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `NAME` varchar(255) NOT NULL default '',
  `COMMENTS` longtext NOT NULL,
  PRIMARY KEY  (`ID`)
) ; 

LOCK TABLES `users_level` WRITE;
INSERT INTO `users_level` VALUES (10,'Distribution Administrator','Full access to all RPM tasks'),(20,'Package Manager','Full access to owned RPMS, including approval of tester modifications.  Approval of changes to any unowned RPMS is still required.'),(30,'Tester','Modification access to all RPMS, pending approval of package or distribution manager.'),(40,'Guest','View-only access');
UNLOCK TABLES;

